#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Bresenham circle 2", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    int cX = SCREEN_WIDTH  / 2;
    int cY = SCREEN_HEIGHT / 2;
    int r = 150;

    int x = 0;
    int y = r;

    while (x <= y)
    {
        gfx.setPixel(cX + x, cY + y, Color(255, 255, 255));
        gfx.setPixel(cX + x, cY - y, Color(255, 255, 255));
        gfx.setPixel(cX - x, cY + y, Color(255, 255, 255));
        gfx.setPixel(cX - x, cY - y, Color(255, 255, 255));
        gfx.setPixel(cX + y, cY + x, Color(255, 255, 255));
        gfx.setPixel(cX + y, cY - x, Color(255, 255, 255));
        gfx.setPixel(cX - y, cY + x, Color(255, 255, 255));
        gfx.setPixel(cX - y, cY - x, Color(255, 255, 255));

        x++;

        if (sqrt(x * x + y * y) > r)
            y--;
    }

    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
